`include "define.h"
`timescale 1ns/1ps
module ALU_test;
	reg clock=0;
	reg sync_reset;
	reg [1:0] alu_left_sel;
	reg [3:0] alu_right_sel;
	reg [4:0] ope;
	reg imm_sel;
	reg v_clear;
	reg h_latch,n_latch,z_latch,v_latch,c_latch;
	reg ccr_all_write;
	reg [1:0] alu_access_mode;
	reg [31:0] RO_left,RO_right,MOUT;
	reg [63:0] irword;
	reg [1:0] bus_state;
	reg [1:0] ccr_reg_sel;
	wire [31:0] z_bus;
	wire [7:0] CCR;
	wire BCC_jmp;
	wire i_bit;
	wire stop_state;
	reg [7:0] state;
	reg [31:0] mul_div_dest_reg;//Jun.3.2004		
	reg mul_div_address3;//Jun.3.2004
	reg [3:0] ea_reg_address;
	reg [1:0] ea_input_sel;
	reg [1:0] ccr_input_sel;
	reg [31:0] reg_out_for_mul_div;

	integer i;

	always #10 clock=~clock;
	


	initial begin
		sync_reset=1;
	
		
		alu_left_sel=0;
		alu_right_sel=4;
		ope=2;
		imm_sel=0;
		v_clear=0;
		h_latch=0;
		n_latch=0;
		z_latch=0;
		v_latch=0;
		c_latch=0;
		ccr_all_write=0;
		alu_access_mode=2;
		RO_left=32'h0000_eac0;
		RO_right=32'h0000_1111;
		MOUT=0;
		irword=0;
		bus_state=2;
		ccr_reg_sel=0;
		#1000;
	sync_reset=0;
		for (i=0; i<10000;i=i+1) begin
				@(negedge clock) RO_left=RO_left+1;
			end
		end


ALU alu(.clock(clock),.sync_reset(sync_reset),.alu_left_sel(alu_left_sel),
        .alu_right_sel(alu_right_sel),.ope(ope),.imm_sel(imm_sel),.v_clear(v_clear),
	  .h_latch(h_latch),.n_latch(n_latch),.z_latch(z_latch),.v_latch(v_latch),.c_latch(c_latch),
	  .ccr_all_write(ccr_all_write),.access_mode(alu_access_mode),
	  .RO_left(RO_left),.RO_right(RO_right),.irword(irword),.MOUT(MOUT),
	  .bus_state(bus_state),.ccr_input_sel(ccr_input_sel),.z_bus(z_bus),.CCR(CCR),.BCC_jmp(BCC_jmp),.i_bit(i_bit),.stop_state(stop_state),.state(state),
	  .mul_div_dest_reg(reg_out_for_mul_div),.mul_div_address3(ea_reg_address[3]));//Jun.3.2004


endmodule










