`timescale 1ns/1ps
`define CYCLE (10)
module h8_test;
	reg clock=0;
	reg sync_reset=1;
	wire [31:0] MOUT;
	reg int_req2=0;
	wire int_req2_ack;
	wire [13:0] monitor_daddr,monitor_paddr;
	wire  [31:0] monitor_in_data;
	wire  monitor_ram_write;
	integer f1;
       initial begin
//		f1=$fopen("h8_check.txt");
	#10000;
		int_req2=1;
		wait(int_req2_ack);
		int_req2=0;

	end	
	

 H8  cpu(.clock(clock),.sync_reset(sync_reset),.MOUT(MOUT),.int_req2(int_req2),
	 .int_req2_ack(int_req2_ack),.monitor_daddr(monitor_daddr),
	 .monitor_in_data(monitor_in_data), .monitor_ram_write(monitor_ram_write),.monitor_paddr(monitor_paddr));

//	always @ (posedge clock) begin
//		$fdisplay(f1,"prg=%h data=%h mout=%h daddr=%h ram_write=%b time=%d",monitor_paddr,monitor_in_data,MOUT,monitor_daddr,monitor_ram_write,$time);
//	end


	always #(`CYCLE) clock=~clock;
		initial begin 
			#705 ;
			sync_reset=0;
			#65000000;
			$finish;
		end
     //TAK                             
      `define Print_Port_Address     14'h0070  
      `define Print_CAHR_Port_Address 14'h0072
      `define Print_INT_Port_Address  14'h0074
      `define Print_LONG_Port_Address 14'h0076

reg [0:639] char_buffer;
	task Cprint;// String OUT until the byte 00 or xx detected with least Byte first and justified.
		integer i;
		begin :Block
			i=0;
			while (1) begin
				if (char_buffer[i*8 +:8] ===8'h00 || char_buffer[i*8 +:8]===8'hxx) begin
						disable Block;
				end	
				$write("%c",char_buffer[i*8 +:8]);
				i=i+1;  
			end
		end
	endtask

   
   integer  counter=0;    
   always @ (posedge clock ) begin
            if ((monitor_ram_write === 1'b1)) begin 
           	   if (monitor_daddr==`Print_Port_Address) begin
				if (monitor_in_data[7:0]===8'h00) begin
					char_buffer[counter*8 +:8]=monitor_in_data[7:0];
					if (char_buffer[0  +:8*7]==="$finish") begin
							$finish;				
							
					end else if (char_buffer[0  +:8*5]==="$time") begin
							$display("Current Time on Simulation=%d",$time);				
							
					end else  Cprint;//$write("%s",char_buffer);

					for (counter=0; counter< 80; counter=counter+1) begin
						char_buffer[counter*8 +:8]=8'h00;
					end
					counter=0;
				
				end else begin
					char_buffer[counter*8 +:8]=monitor_in_data[7:0];
					counter=counter+1;
				end
		   end
       	   else if (monitor_daddr==`Print_CAHR_Port_Address) begin
				$write("%h ",monitor_in_data[7:0]);
		   end else if (monitor_daddr==`Print_INT_Port_Address) begin
				$write("%h ",monitor_in_data[15:0]);//Little Endian 
		   end else if (monitor_daddr==`Print_LONG_Port_Address) begin
				$write("%h ",monitor_in_data[31:0]);//Big Endian
		   end 
	end //if
   end //always


endmodule